//************************************************************************************
//**  
//**  File name:     C:\DEV\EB-033 PS2 VGA\Software\PS2 Keyboard\PS2_Key.c
//**  Generated by:  Flowcode v3.1.0.31
//**  Date:          Tuesday, February 13, 2007 11:56:47
//**  Licence:       Professional
//**  Registered to: Ben Rowland
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


//Defines for microcontroller
#define P16F877A
#define MX_EE
#define MX_EE_TYPE2
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_PORT portc
#define MX_PWM_TRIS trisc
#define MX_PWM_CNT 2
#define MX_PWM_1 2
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 19660800

//Configuration data
#pragma DATA 0x2007, 0x3f3a

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_Int_Handle();


//Variable declarations
short FCV_I;
char FCV_K;




//RS2320: //Macro function declarations

void FCD_RS2320_SendRS232Char(char Char);
char FCD_RS2320_ReceiveRS232Char(char timeout);

//Supplementary defines
#include <PS2_Keyboard.c>

//Macro implementations

void FCM_Int_Handle()
{
	
	//Calculation
	//Calculation:
	//  k = 0
	FCV_K =  0 ;
	

	//C Code
	//C Code:
	FCV_K = processByte();


	//Decision
	//Decision: k <> 0?
	if( FCV_K != 0 )
	{
		//C Code
		//C Code:
		kbBuffer[kbPos] = FCV_K;


		//C Code
		//C Code:
		kbPos = ++kbPos & 0x0F;



		//C Code
		//C Code:
		kbSize++;



	}


}



//RS2320: //Macro implementations


void FCD_RS2320_SendRS232Char(char Char)
{
	    //GetSendRS232CharCode

	#define fc_rsSTATUS_LOOP      0
	#define fc_rsSTATUS_TIMEOUT   1
	#define fc_rsSTATUS_RXBYTE    2


	   set_bit(txsta, TXEN);

	   while ((pir1 & (1<< TXIF)) == 0);

	   txreg = Char;
	    
}

char FCD_RS2320_ReceiveRS232Char(char timeout)
{
	    //GetReceiveRS232CharCode

	#define fc_rsSTATUS_LOOP      0
	#define fc_rsSTATUS_TIMEOUT   1
	#define fc_rsSTATUS_RXBYTE    2

	   char delay1 = 0;
	   char delay2 = 0;
	   char dummy = 0;
	   char retVal = 255;
	   char bWaitForever = 0;
	   char rxStatus = fc_rsSTATUS_LOOP;


	   if (timeout == 255)
	   {
	       bWaitForever = 1;
	   }

	   set_bit(rcsta, CREN);

	   while (rxStatus == fc_rsSTATUS_LOOP)
	   {
	       if ((pir1 & (1 << RCIF)) != 0)
	       {
	           //received a Char
	           rxStatus = fc_rsSTATUS_RXBYTE;
	       } else {
	           if (bWaitForever == 0)
	           {
	               //don't wait forever, so do timeout thing...
	               if (timeout == 0)
	               {
	                   rxStatus = fc_rsSTATUS_TIMEOUT;
	                   #ifdef fc_rs232_debug
	                       //FCD_RS2320_SendRS232Char('<');
	                       //FCD_RS2320_SendRS232Char('t');
	                       //FCD_RS2320_SendRS232Char('i');
	                       //FCD_RS2320_SendRS232Char('m');
	                       //FCD_RS2320_SendRS232Char('e');
	                       //FCD_RS2320_SendRS232Char('o');
	                       //FCD_RS2320_SendRS232Char('u');
	                       //FCD_RS2320_SendRS232Char('t');
	                       //FCD_RS2320_SendRS232Char('>');
	                   #endif
	               } else {
	                   //decrement timeout
	                   delay1--;
	                   if (delay1 == 0)
	                   {
	                           timeout--;
	                   }
	               }
	           }
	       }
	   }

	   if (rxStatus == fc_rsSTATUS_RXBYTE)
	   {
	       if ((rcsta & (1 <<FERR)) != 0)
	       {
	           dummy = rcreg;      //need to read the rcreg to clear FERR
	           #ifdef fc_rs232_debug
	               FCD_RS2320_SendRS232Char('<');
	               FCD_RS2320_SendRS232Char('F');
	               FCD_RS2320_SendRS232Char('E');
	               FCD_RS2320_SendRS232Char('R');
	               FCD_RS2320_SendRS232Char('R');
	               FCD_RS2320_SendRS232Char('>');
	           #endif
	       } else {
	       if ((rcsta & (1 << OERR)) != 0)
	           {
	               //need to read the rcreg to clear error
	               clear_bit(rcsta, CREN);
	               set_bit(rcsta, CREN);
	               #ifdef fc_rs232_debug
	                   FCD_RS2320_SendRS232Char('<');
	                   FCD_RS2320_SendRS232Char('O');
	                   FCD_RS2320_SendRS232Char('E');
	                   FCD_RS2320_SendRS232Char('R');
	                   FCD_RS2320_SendRS232Char('R');
	                   FCD_RS2320_SendRS232Char('>');
	               #endif
	           } else {
	               retVal = rcreg; //no error, so rx byte is valid
	               #ifdef fc_rs232_echo
	                   FCD_RS2320_SendRS232Char(retVal);
	               #endif
	           }
	       }
	   }


	   return (retVal);
}

//Supplementary implementations


void main()
{
	
	//Initialisation
	adcon1 = 0x07;

	   // RS232 initialiasation code

	#define fc_rsSTATUS_LOOP      0
	#define fc_rsSTATUS_TIMEOUT   1
	#define fc_rsSTATUS_RXBYTE    2

	   txsta = 4; // 8-bit, async, low speed, off
	   spbrg = 127; // set the baud rate
	   rcsta = 0;              // 8-bit, disabled
	   set_bit(rcsta, SPEN);   // turn on serial interface
	 

	//Interrupt initialisation code
	option_reg = 0xC0;


	//Calculation
	//Calculation:
	//  i = 0
	//  k = 0
	FCV_I =  0 ;
	FCV_K =  0 ;
	

	//Call Component Macro
	//Call Component Macro: RS232(0)::SendRS232Char("Ready")
	FCD_RS2320_SendRS232Char('R');
	FCD_RS2320_SendRS232Char('e');
	FCD_RS2320_SendRS232Char('a');
	FCD_RS2320_SendRS232Char('d');
	FCD_RS2320_SendRS232Char('y');


	//Call Component Macro
	//Call Component Macro: RS232(0)::SendRS232Char(13)
	FCD_RS2320_SendRS232Char(13);


	//C Code
	//C Code:
	PS_PORT.DATA = (0x00);
	trisb = 0xFF;



	//Delay
	//Delay: 100 ms
	delay_ms(100);


	//Interrupt
	//Interrupt: Enable RB0/INT
	option_reg.INTEDG=0;
	intcon.GIE=1;
	intcon.INTE=1;


	//Loop
	//Loop: While 1
	while( 1 )
	{
		//C Code
		//C Code:
		FCV_K = waitKey();



		//Call Component Macro
		//Call Component Macro: RS232(0)::SendRS232Char(k)
		FCD_RS2320_SendRS232Char(FCV_K);


		//C Code
		//C Code:
		while(keyhit())
		{
		     FCD_RS2320_SendRS232Char(waitKey());
		}



	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (intcon & (1 << INTF))
	{
		FCM_Int_Handle();
		clear_bit(intcon, INTF);
	}

}

