	title		"Rob's graphics routines"
	subtitle	""

plot	macro	x,y
		movlw	x
		movwf	xpos
		movlw	y
		movwf	ypos
		call	doplot
		endm

hline	macro	x1,x2,y
		movlw	x1
		movwf	xpos1
		movlw	x2
		movwf	xpos2
		movlw	y
		movwf	ypos
		call	dohline
		endm

vline	macro	y1,y2,x
		movlw	y1
		movwf	ypos1
		movlw	y2
		movwf	ypos2
		movlw	x
		movwf	xpos
		call	dovline
		endm

cls		macro
		call	docls
		endm


xpos		=	0xe0
ypos		=	0xe1
fcolor		=	0xe2
xpos1		=	0xe3
ypos1		=	0xe4
xpos2		=	0xe5
ypos2		=	0xe6
bcolor		=	0xe7

; Clear the screen
docls	clrf	fcolor
		clrf	xpos1
		clrf	ypos1
		movlw	screenheight
		movwf	ypos2
		movff	xpos1,xpos
_clear	movlw	screenwidth-1
		cpfslt	xpos
		return
		call	dovline
		incf	xpos
		; next color
		incf	fcolor,F
		movlw	0x0f
		andwf	fcolor,F
		movf	fcolor,W
		swapf	WREG
		iorwf	fcolor,F
		bra		_clear

; Plots a point at xpos,ypos with given color.
; Uses FSR1 and hardware multiplier.
doplot	movlw	pixelpairs
		mulwf	ypos		; screenwidth*ypos => PRODH:PRODL
		movff	PRODH,FSR1H
		movff	PRODL,FSR1L
		rrncf	xpos,W		; rotate right, no carry
		bcf		WREG,7		; ensure high bit off
		addwf	FSR1L,F
		movlw	high videomemory
		addwfc	FSR1H,F
		btfsc	xpos,0		; low bit indicates left/right pixel
		goto	_plothi
_plotlo	movlw	0xf0
		bra		_plot2
_plothi	movlw	0x0f
_plot2	andwf	INDF1,F
		comf	WREG
		andwf	fcolor,W
		iorwf	INDF1,F
		return

; Plots a vertical line from xpos,ypos1 to xpos,ypos2
; in the current color.  Reuses plot and over-writes
; the ypos value.
dovline	movff	ypos1,ypos
_vline	movf	ypos2,W
		cpfslt	ypos	; compare, branch if lessthan
		return	; done!
		call	doplot
		incf	ypos,F
		bra		_vline

; Plots a horizontal line from xpos1,ypos to xpos2,ypos
; in the current color.  Reuses plot and over-writes
; the xpos value.  No optimizations have been done.
dohline	movff	xpos1,xpos
_hline	movf	xpos2,W
		cpfslt	xpos
		return	; done!
		call	doplot
		incf	xpos,F
		bra		_hline
