//************************************************************************************
//**  
//**  File name:     C:\DEV\Eblocks\EB-033 PS2 VGA\Software\VGA Control\VGA_Tester.c
//**  Generated by:  Flowcode v3.1.1.33
//**  Date:          Thursday, March 29, 2007 12:56:34
//**  Licence:       Professional
//**  Registered to: Ben Rowland
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


//Defines for microcontroller
#define P16F877A
#define MX_EE
#define MX_EE_TYPE2
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 19660800

//Configuration data
#pragma DATA 0x2007, 0x3f3a

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_TMR_TimeOut();
void FCM_H_Pulse();
void FCM_V_Pulse();
void FCM_H_P();


//Variable declarations
char FCV_INNER;
short FCV_COUNT;
char FCV_DATAOUT;
char FCV_INDEX;



//Supplementary defines
#define PORT portd
#define TRIS trisd
#define HS 1
#define VS 0
#define RDAT 6
#define GDAT 5
#define BDAT 2

char DATAR[3] = {1,0,0};
char DATAG[3] = {0,1,0};
char DATAB[3] = {0,0,1};

//Macro implementations

void FCM_TMR_TimeOut()
{
	
	//Interrupt every 32.77us
	//C Code:
	tmr0 = 124;


	//Decrement counter
	//Calculation:
	//  count = count - 1
	FCV_COUNT =  FCV_COUNT - 1 ;
	

	//Decision
	//Decision: count < 70?
	if( FCV_COUNT < 70 )
	{
		//Call Macro
		//Call Macro: H_P
		FCM_H_P();


	} else {
		//Decision
		//Decision: count > 460?
		if( FCV_COUNT > 460 )
		{
			//Call Macro
			//Call Macro: H_P
			FCM_H_P();


		} else {
			//Call Macro
			//Call Macro: H_Pulse
			FCM_H_Pulse();


		}


	}


	//Time for V Pulse?
	//Decision: count = 0?
	if( FCV_COUNT == 0 )
	{
		//Clear counter
		//Calculation:
		//  count = 510
		FCV_COUNT =  510 ;
		

		//Call Macro
		//Call Macro: V_Pulse
		FCM_V_Pulse();


	}


}

void FCM_H_Pulse()
{
	
	//H Sync Pulse - 3.77us
	//C Code:
	clear_bit (PORT, HS);
	asm
	{
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	}
	set_bit(PORT, HS);


	//Back Porch Delay - 1.89us
	//C Code:
	asm
	{
	    nop
	    nop
	    nop
	    nop
	}


	//Data Line
	//C Code:
	if(DATAR[FCV_INDEX]) set_bit(PORT, RDAT);
	else
	{
	  clear_bit(PORT, RDAT); 
	  asm
	  { 
	     nop 
	  }
	}
	if(DATAG[FCV_INDEX]) set_bit(PORT, GDAT);
	else
	{
	  clear_bit(PORT, GDAT); 
	  asm
	  { 
	     nop 
	  }
	}
	if(DATAB[FCV_INDEX]) set_bit(PORT, BDAT);
	else
	{
	  clear_bit(PORT, BDAT); 
	  asm
	  { 
	     nop 
	  }
	}


	//C Code
	//C Code:
	asm
	{
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	}



	//C Code
	//C Code:
	PORT = PORT & 3;

	FCV_INNER++;
	if(FCV_INNER == 20) 
	{
	    FCV_INNER = 0;
	    FCV_INDEX++;
	    if(FCV_INDEX == 3) FCV_INDEX = 0;
	}


}

void FCM_V_Pulse()
{
	
	//V Sync Pulse - 0.06ms
	//C Code:
	int k;
	clear_bit(PORT, VS);
	for(k=0;k<24;k++);
	set_bit(PORT, VS);


}

void FCM_H_P()
{
	
	//H Sync Pulse - 3.77us
	//C Code:
	clear_bit (PORT, HS);
	asm
	{
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	    nop
	}
	set_bit(PORT, HS);
	FCV_INDEX = 0;
	FCV_INNER = 0;


}

//Supplementary implementations


void main()
{
	
	//Initialisation
	adcon1 = 0x07;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Init Hardware
	//C Code:
	clear_bit(TRIS, HS);
	clear_bit(TRIS, VS);
	clear_bit(TRIS, RDAT);
	clear_bit(TRIS, GDAT);
	clear_bit(TRIS, BDAT);

	set_bit(PORT, HS);
	set_bit(PORT, VS);



	//Trigger V Pulse At Start
	//Calculation:
	//  count = 1
	FCV_COUNT =  1 ;
	

	//Interrupt
	//Interrupt: Enable TMR0 Overflow
	option_reg.T0CS=0;
	option_reg.T0SE=1;
	option_reg = (option_reg & 0xF0) | 0x08;
	intcon.GIE=1;
	intcon.T0IE=1;


	//Loop
	//Loop: While 1
	while( 1 )
	{
	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (intcon & (1 << T0IF))
	{
		FCM_TMR_TimeOut();
		clear_bit(intcon, T0IF);
	}

}

